/***************************************************************************
                          prototypedoc.h  -  description
                             -------------------
    begin                : Thu May 15 22:50:15 CEST 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef PROTOTYPEDOC_H
#define PROTOTYPEDOC_H

// include files for QT
#include <qobject.h>
#include <qptrlist.h>

// application specific includes

class Block;
class BlockList;
class Successor;
class QString;

/**
  * the Document Class
  */
class ProtoTypeDoc : public QObject
{
	Q_OBJECT

public:
	ProtoTypeDoc();
	~ProtoTypeDoc();
	void newDoc();
	bool save();
	bool saveAs(const QString &filename);
	bool load(const QString &filename);
	bool isModified() const;
	void setConfigPrototypePath( QString dir );
	void setConfigLanguage( QString lang );

	BlockList* getBlockList();
	void clearVisited();
	void clearPrinted();
	QString getCurrentProtocol();
	/** No descriptions */
	void setConfigMaxCharactersPerLine(int cpl);
	Block* getBlock( int id );
  /** No descriptions */
  QString getCurrentProtocolFilename();

public slots:
	void loadProtocol( QString protocol );

signals:
	void documentChanged();

protected:
	bool modified;
	void rebuildProtocolTree( Block* b, int depth );
	void checkProtocolTree( Block* b );

private:
	//    QPtrList<Block> blocklist;
	BlockList* blocklist;
	int x_coord;
	QString config_protocol_path;
	QString config_language;
	QString currentProtocol;
	Block* startblock;
	Successor* sux;
	int maxBlockID;
	int config_max_characters_per_line;
	QString stripBlanks( QString txt );
	QString currentProtocolFilename;


};

#endif
